from netgen.csg import *
from netgen.meshing import *
from ngsolve import *

geo = CSGeometry()
sphere = Sphere(Pnt(0,0,0),1).bc("outer")
geo.Add(sphere)
meshCoarse = Mesh(geo.GenerateMesh(perfstepsend=MeshingStep.MESHSURFACE,optsteps2d=3,maxh=0.5))

fesCoarse = H1(meshCoarse,order = 1)

gfudCoarse = GridFunction(fesCoarse)
gfudCoarse.Set(x*y**2, definedon = meshCoarse.Boundaries("outer"))

ngmeshCoarseCopy = meshCoarse.ngmesh.Copy()
ngmeshCoarseCopy.Refine()
ngmeshCoarseCopy.Refine()
mesh = Mesh(ngmeshCoarseCopy)

fes = H1(mesh,order = 1)
gfud = GridFunction(fes)

print(Norm(gfudCoarse.vec))
#gfud.Set(gfudCoarse, BND)      ## sets gfudCoarse to zero
gfud.Set(gfudCoarse, BND, definedon=mesh.Boundaries("outer"))  ## gives segmentation fault
print(Norm(gfud.vec))

Draw(gfud, mesh, "gfud")
input("end")
